# Simple Random File Access
# Example Code
#
# def update_attack(ip)
#   rtf = RandomFile.new
#
#   found = false
#   counter = 1
#   while !rtf.eof do
#     puts rtf.pos
#     res = rtf.read
#     m = res.split(9.chr)
#     if m[0] == ip
#       counter = m[1].to_i + 1
#       rtf.seek(rtf.pos-1)
#       rtf.write(ip+9.chr+counter.to_s)
#       puts ip+9.chr+counter.to_s
#       found = true
#       break
#     end
#   end
#   if !found
#     rtf.append
#     rtf.write(ip+9.chr+counter.to_s)
#   end
#   rtf.close
# end
#
# def clear_attack(ip)
#   rtf = RandomFile.new
#
#   found = false
#   counter = 0
#   while !rtf.eof do
#     res = rtf.read
#     m = res.split(9.chr)
#     if m[0] == ip
#       rtf.seek(rtf.pos-1)
#       rtf.write(ip+9.chr+counter.to_s)
#       puts ip+9.chr+counter.to_s
#       found = true
#       break
#     end
#   end
#   if !found
#     rtf.append
#     rtf.write(ip+9.chr+counter.to_s)
#   end
#   rtf.close
# end
#
# Arguments:
#  filename = name of file
#  recordsize (default = 80)
 
 
 class RandomFile
   def initialize(filename = nil,recordsize = 80)
     if filename == nil
        filename = File.join(Rails.root, 'log', 'NoNameR-'+Time.now.localtime.strftime("%Y-%m-%d")+".log")
     end
     @recordsize = recordsize
     if FileTest::exist?(filename)
       @file = File.new(filename, 'r+')
     else
       @file = File.new(filename, 'w+')
     end
   end
   
   def eof
     return @file.eof? 
   end
   
   def pos
     return @file.pos / @recordsize
   end
   
   def write(val)
     while val.length < @recordsize
       val = val + 0.chr
     end
     @file.write val
   end
   
   def seek(posn)
     @file.seek(@recordsize * posn)
   end
   
   def append
     @file.seek(0,IO::SEEK_END)
   end
   
   def close
     @file.close
   end
   
   def read
     res = @file.read(@recordsize)
     posn = res.index(0.chr)
     if posn != nil
       res = res[0,posn]
     end
     return res
   end
   
   
 end
